<?php
/**
 * 2018 Paysera
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author Paysera <plugins@paysera.com>
 * @copyright 2018 Paysera
 * @license http://opensource.org/licenses/afl-3.0.php Academic Free License (AFL 3.0)
 * International Registered Trademark & Property of Paysera
 */

declare(strict_types=1);

namespace Paysera\Delivery\Entity;

if (!defined('_PS_VERSION_')) {
    exit;
}

use Cart;

class MerchantCart implements MerchantCartInterface
{
    /**
     * @var Cart
     */
    private $cart;

    public function __construct(Cart $cart)
    {
        $this->cart = $cart;
    }

    public function getCart(): Cart
    {
        return $this->cart;
    }

    public function setCarrierId(int $carrierId): MerchantCartInterface
    {
        $this->cart->id_carrier = $carrierId;

        return $this;
    }

    public function getShippingTotal(bool $withTaxes): float
    {
        return $this->cart->getOrderTotal($withTaxes, Cart::ONLY_SHIPPING);
    }

    public function setAddressId(int $addressId): MerchantCartInterface
    {
        $this->cart->id_address_delivery = $addressId;

        return $this;
    }
}
